do return (function()
    math.randomseed(os.time());
    local jailCPS <const>, jailAnims <const>, jailLocs <const> = {}, {"WORLD_HUMAN_GARDENER_LEAF_BLOWER"; "WORLD_HUMAN_GARDENER_PLANT"; "WORLD_HUMAN_PUSH_UPS"; "WORLD_HUMAN_SIT_UPS"; "WORLD_HUMAN_CONST_DRILL"}, {
        vector3(-443.51962280273,6111.8100585938,31.069812774658);
        vector3(-467.24801635742,6094.7934570313,29.967409133911);
        vector3(-443.84024047852,6093.33203125,31.524749755859);
        vector3(-466.23944091797,6112.380859375,29.798763275146);
        vector3(-444.85461425781,6119.1108398438,30.803764343262);
        vector3(-458.20529174805,6080.6870117188,31.297185897827);
        vector3(-447.72702026367,6099.0249023438,31.127384185791);
        vector3(-456.92810058594,6128.6357421875,29.789371490479);
    };

    local getRandomJailCP <const> = function ()
        local indexAnims <const> = math.random(1, #jailAnims);local indexLocs <const> = math.random(1, #jailLocs);
        local cpData <const> = {jailAnims[indexAnims], jailLocs[indexLocs]};
        math.randomseed(os.time());
        return cpData;
    end;

    local isCPDataInArray <const> = function (...)
        local args <const> = {...};
        local cpData <const> = args[1];
        if not cpData then return false end;
        for i = 1, #jailLocs do
            if jailLocs[i] == cpData then
                return true;
            end;
        end;
    end;

    local doneCheckpoints <const> = function (...)
        local args <const> = {...};
        local player <const>, user_id <const> = tonumber(args[1]), tonumber(args[2]);
        if not player or not user_id then return end;
        do return (function()
            jailCPS[user_id] = nil;
            vRPclient.notify(player, {"Ai terminat toate checkpoint-urile."});
            vRPclient.teleport(player, {429.32473754883,-981.73400878906,30.710342407227});
            SetPlayerRoutingBucket(player, 0);
            TriggerClientEvent("ples-jail:stopWeapons", player, false);
        end)() end;
    end;

    local checkCheckpoint <const> = function (...)
        local args <const> = {...};
        local cpData <const> = args[1];
        if not cpData then return end;
        local player <const> = source;
        local user_id <const> = vRP.getUserId{player};
        if not user_id or not jailCPS[user_id] or not isCPDataInArray(cpData) then return end;
        local cpData <const> = getRandomJailCP();
        do return (function()
            jailCPS[user_id] = jailCPS[user_id] - 1;
            if jailCPS[user_id] <= 0 then return doneCheckpoints(player, user_id) end;
            TriggerClientEvent("ples-jail:sendCoords", player, cpData[2], cpData[1], jailCPS[user_id]);
            vRPclient.subtitleTimer(player, {"Admin Jail\nTrebuie sa faci munca in folosul comunitatii !", 10})
        end)() end;
    end;

    local setPlayerInAJail <const> = function (...)
        local args <const> = {...};
        local user_id <const>, cps <const> = tonumber(args[1]), tonumber(args[2]);
        if not user_id or jailCPS[user_id] or not cps then return end;
        local target <const> = vRP.getUserSource{user_id};
        if not target then return exports.oxmysql:execute('UPDATE vrp_users SET aJailCP = @cps WHERE id = @user_id', {["user_id"] = user_id; ["cps"] = cps}) end;
        local cpData <const> = getRandomJailCP();
        do return (function()
            jailCPS[user_id] = cps;
            SetPlayerRoutingBucket(target, 1337);
            TriggerClientEvent("ples-jail:sendCoords", target, cpData[2], cpData[1], jailCPS[user_id]);
            TriggerClientEvent("ples-jail:stopWeapons", target, true);
            vRPclient.teleport(target, {-473.73126220703,6098.5834960938,29.721248626709});
            vRPclient.subtitleTimer(target, {"Admin Jail\nTrebuie sa faci munca in folosul comunitatii !", 10})
        end)() end;
    end;

    local AdminJailChoice <const> = function (...)
        local args <const> = {...};
        local player <const> = args[1];
        local user_id <const> = vRP.getUserId{player};
        if not user_id then return end;
        vRP.prompt{player, "ID: ", "", function(...)
            local args <const> = {...};
            local target_id <const> = tonumber(args[2]);
            if not target_id then return vRPclient.notify(player, {"Id invalid!"}); end;
            vRP.prompt{player, "Checkpoint-uri: ", "", function (...)
                local args <const> = {...};
                local cps <const> = tonumber(args[2]);
                if not cps or cps < 1 or cps > 500 then return vRPclient.notify(player, {"Poti da minim 1 Checkpoint sau maxim 500 Checkpoint-uri!"}); end;
                vRP.prompt{player, "Motiv: ", "", function (...)
                    local args <const> = {...};
                    local motiv <const> = tostring(args[2]);
                    if not motiv or motiv:len() < 2 or motiv:len() > 64 then return vRPclient.notify(player, {"Motiv invalid!"}); end;
                    local target_player <const> = vRP.getUserSource{target_id};
                    if not target_player then
                        do return (function()
                            exports.oxmysql:execute("SELECT aJailCP, username FROM vrp_users WHERE id = @user_id", {["user_id"] = target_id}, function (result)
                                local result <const> = result[1];
                                if not result then return end;
                                do return (function()if (result.aJailCP or 0) >= 1 then return vRPclient.notify(player, {"Jucatorul are deja jail!"}) end;do return (function()local aName <const> = (GetPlayerName(player) or "Unknown"); local tName <const> = (result.username or "Unknown"); setPlayerInAJail(target_id, cps); TriggerClientEvent('chatMessage',-1,"Adminul ^1"..aName.."^0[^1"..user_id.."^0] i-a dat jail [^1"..cps.."^0] checkpoint-uri^0 jucatorului [^1"..tName.."^0][^1"..target_id.."^0]: [^1"..motiv.."]");end)()end;end)() end;
                            end);
                        end)() end;
                    end;
                    if jailCPS[target_id] then return vRPclient.notify(player, {"Jucatorul are deja jail!"}) end;
                    do return(function()
                        local aName <const> = (GetPlayerName(player) or "Unknown");
                        local tName <const> = (GetPlayerName(target_player) or "Unknown");
                        setPlayerInAJail(target_id, cps);
                        TriggerClientEvent('chatMessage',-1,"Adminul [^1"..aName.."^0] [^1"..user_id.."^0] i-a dat jail [^1 "..cps.." ^0] checkpoint-uri jucatorului [^1 "..tName.." ^0] [^1"..target_id.."^0] = ^0[ ^1"..motiv.." ^0]");
                    end)() end;
                end};
            end};
        end};
    end;

    local AdminUnJailChoice <const> = function (...)
        local args <const> = {...};
        local player <const> = args[1];
        local user_id <const> = vRP.getUserId{player};
        if not user_id then return end;
        vRP.prompt{player, "ID: ", "", function(...)
            local args <const> = {...};
            local target_id <const> = tonumber(args[2]);
            if not target_id then return vRPclient.notify(player, {"ID invalid!"}); end;
            local target_player <const> = vRP.getUserSource{target_id};
            if not target_player then
                do return (function()
                    exports.oxmysql:execute("SELECT aJailCP, username FROM vrp_users WHERE id = @user_id", {["user_id"] = target_id}, function (result)
                        local result <const> = result[1];
                        if not result then return end;
                        do return (function()if (result.aJailCP or 0) <= 0 then return vRPclient.notify(player, {"Jucatorul nu are jail!"}) end;do return (function()local aName <const> = (GetPlayerName(player) or "Unknown"); local tName <const> = (result.username or "Unknown"); exports.oxmysql:execute("UPDATE vrp_users SET aJailCP = @cps WHERE id = @user_id", {["user_id"] = target_id; ["cps"] = cps}); TriggerClientEvent('chatMessage',-1,"Adminul ^1"..aName.."^0(^1"..user_id.."^0) i-a dat unjail jucatorului ^1"..tName.."^0(^1"..target_id.."^0)"); end)()end;end)() end;
                    end);
                end)() end;
            end;
            if not jailCPS[target_id] then return vRPclient.notify(player, {"Jucatorul nu are jail!"}) end;
            do return(function()
                local aName <const> = (GetPlayerName(player) or "Unknown");
                local tName <const> = (GetPlayerName(target_player) or "Unknown");
                doneCheckpoints(target_player, target_id);
                TriggerClientEvent('chatMessage',-1,"Adminul [^1"..aName.."^0] [^1"..user_id.."^0] i-a dat unjail jucatorului [^1 "..tName.." ^0] [^1"..target_id.."^0 ]");
            end)() end;
        end}
    end;

    local JailRegisterMenu <const> = function (...)
        local args <const> = {...};
        local add <const>, data <const> = args[1], args[2];
        if not add or not data then return end;
        local user_id <const> = vRP.getUserId{data.player};
        if not user_id then return end;
        local choices <const> = {};
        if vRP.isUserTrialHelper{user_id} then
            choices["Admin Jail"] = {AdminJailChoice, "Baga un jucator la Admin Jail"};
            choices["Admin UnJail"] = {AdminUnJailChoice, "Scoate un jucator de la Admin Jail"};
        end;
        add(choices);
    end;

    local playerJoinHandler <const> = function (...)
        local args <const> = {...};
        local user_id <const> = args[1];
        exports.oxmysql:execute("SELECT aJailCP FROM vrp_users WHERE id = @user_id", {["user_id"] = user_id}, function (result)
            local result <const> = result[1];
            if not result then return end;
            do return (function()jailCPS[user_id] = tonumber(result.aJailCP);end)() end;
        end);
    end;

    local playerSpawnHandler <const> = function (...)
        local args <const> = {...};
        local user_id <const>, player <const>, fs <const> = args[1], args[2], args[3];
        if not fs or not jailCPS[user_id] then return end;
        SetTimeout(5000, function()
            local cpData <const> = getRandomJailCP();
            do return (function()
                SetPlayerRoutingBucket(player, 1337);
                TriggerClientEvent("ples-jail:sendCoords", player, cpData[2], cpData[1], jailCPS[user_id]);
                TriggerClientEvent("ples-jail:stopWeapons", player, true);
                vRPclient.teleport(player, {-473.73126220703,6098.5834960938,29.721248626709});
                vRPclient.subtitleTimer(player, {"Admin Jail\nTrebuie sa faci munca in folosul comunitatii !", 10})
            end)() end;
        end);
    end;

    local playerLeaveHandler <const> = function (...)
        local args <const> = {...};
        local user_id <const> = args[1];
        local cps <const> = tonumber(jailCPS[user_id]);
        do return (function()
            exports.oxmysql:execute('UPDATE vrp_users SET aJailCP = @cps WHERE id = @user_id', {["user_id"] = user_id; ["cps"] = cps});
            jailCPS[user_id] = nil;
        end)() end;
    end;

    vRP.registerMenuBuilder{"admin", JailRegisterMenu};

    RegisterNetEvent("ples-jail:checkCheckpoint", checkCheckpoint);
    AddEventHandler("vRP:playerJoin", playerJoinHandler);
    AddEventHandler("vRP:playerSpawn", playerSpawnHandler);
    AddEventHandler("vRP:playerLeave", playerLeaveHandler);

end)() end;